#include "addOctTreeSceneNodeC.h"
#include "CleverException.h"
addOctTreeSceneNodeC::addOctTreeSceneNodeC(Command C)
{
	try
	{
		parent=0;
		if(C.exist("parent_id")>=0)
		{
			parent=0;	
			ObDbElement *el=ObDb::getById(Convert::stringwToLong(C.getVarValue("parent_id")));			
			if((el->type==ObDbElementType::node)&&(el->stype==ObDbSceneElementType::SceneNode))
			{			
				this->parent=(ISceneNode*)el->native;				
			}
			else
			{
				CleverException* ce=new CleverException("addOctTreeSceneNodeC");
				ce->setErrorMessage("Bad ObDbElement type(node expected)");
				throw ce;
			}
		}
		ObDbElement *el=ObDb::getById(Convert::stringwToLong(C.getVarValue("mesh_id")));		
		if((el->type==ObDbElementType::part)&&(el->stype==ObDbSceneElementType::Mesh))
		{			
			msh=(IAnimatedMesh*)el->native;				
		}	
		else
		{
			CleverException* ce=new CleverException("addOctTreeSceneNodeC");
			ce->setErrorMessage("Bad ObDbElement type(mesh expected)");
			throw ce;
		}
		mppn=Convert::stringwToLong(C.getVarValue("mppn"));
	}
	catch(CleverException* ice)
	{
		CleverException* ce=new CleverException("addOctTreeSceneNodeC");
		ce->setInner(ice);
		throw ce;
	}

}